#ifndef LIST_H
#define LIST_H

struct list_head {
    struct list_head *next, *prev;
};

#define LIST_HEAD(name)                                     \
    struct list_head name = { &(name), &(name) }

#define list_for_each(pos, head)                            \
    for (pos = (head)->next; pos != head; pos = pos->next)

#define list_entry(ptr, type, member)                       \
    (type*)((char*)ptr - __builtin_offsetof(type, member))

void list_add(struct list_head *item, struct list_head *head);

void list_del(struct list_head *item);

#endif