#include <fcntl.h>
#include <stdio.h>
#include <stdint.h>
#include <unistd.h>

/*
 * Hexdump function (from https://gist.github.com/ccbrown/9722406)
 *
 * Parameters:
 *      data        -       pointer to data buffer
 *      size        -       size to dump
 * 
 * Return value:
 *      0 or error code.
 */
void hexdump(const void* data, size_t size)
{
	char ascii[17];
	size_t i, j;
	ascii[16] = '\0';
	for (i = 0; i < size; ++i)
    {
        if (i % 16 == 0)
        {
            printf("%08x:\t", (uint32_t)i);
        }

		printf("%02X ", ((unsigned char*)data)[i]);
		if (((unsigned char*)data)[i] >= ' ' && ((unsigned char*)data)[i] <= '~')
        {
			ascii[i % 16] = ((unsigned char*)data)[i];
		} 
        else
        {
			ascii[i % 16] = '.';
		}

		if ((i+1) % 8 == 0 || i+1 == size)
        {
			printf(" ");
			if ((i+1) % 16 == 0)
            {
				printf("|  %s \n", ascii);
			} 
            else if (i+1 == size)
            {
				ascii[(i+1) % 16] = '\0';
				if ((i+1) % 16 <= 8)
                {
					printf(" ");
				}
				for (j = (i+1) % 16; j < 16; ++j)
                {
					printf("   ");
				}
				printf("|  %s \n", ascii);
			}
		}
	}
}

void dump_to_file(char *filename, void *data, size_t size)
{
	int fd = open(filename, O_WRONLY | O_CREAT, 0600);

	if (fd < 0)
	{
		perror("dump_to_file open()");
		return;
	}

	write(fd, data, size);

	close(fd);
}